## gd4o 1.0~alpha5

=== Makefile ===
PKGNAME = gd

OCAMLC=ocamlc
OCAMLOPT=ocamlopt
OCAMLMKLIB=ocamlmklib
OCAMLFIND=ocamlfind
OCAMLDOC=ocamldoc -html
OCAMLLIB=`$(OCAMLC) -where`

TASKINSTALL  = $(OCAMLFIND) install $(NAME) $(TASKINSTALLOPTS)

# This turns on some checks that should make the library more secure but
# may degrade performance. If you're more concerned about performance than
# security, comment out the next line.
SAFETY_FLAG = -DSAFER
# If you don't have libjpeg, comment out the 'JPEG_LIB' line.
# Similarly for Freetype2.
JPEG_LIB = -ljpeg
FT2_LIB = -lfreetype
CC=gcc
CINCLUDES=-I$(OCAMLLIB) -I/usr/include 
LIBS=-lgd -lpng -lz $(JPEG_LIB) $(FT2_LIB)
ifdef JPEG_LIB
JPEG_FLAG = -DHAVE_JPEG
endif
ifdef FT2_LIB
FT2_FLAG = -DHAVE_FREETYPE
endif
CFLAGS = $(CINCLUDES) -W -Wall -Wno-unused \
	$(JPEG_FLAG) $(FT2_FLAG) $(SAFETY_FLAG)

OCAMLCFLAGS=-labels -unsafe
OCAMLOPTFLAGS=-labels -inline 2

BYTE_OBJECTS  = gd.cmi gd.cmo
NAT_OBJECTS = gd.cmi gd.cmx
C_OBJECTS = gdstubs.o
STUBLIBS = dllocamlgd.so libocamlgd.a
BYTE_ARCHIVE  = gd.cma
NAT_ARCHIVE = gd.cmxa


.PHONY : all opt install uninstall test test.opt docs
all : $(BYTE_ARCHIVE)
opt : $(NAT_ARCHIVE)


$(BYTE_ARCHIVE) : $(BYTE_OBJECTS) $(C_OBJECTS)
	$(OCAMLMKLIB) -o gd gd.cmo gdstubs.o -oc ocamlgd $(LIBS)
$(NAT_ARCHIVE) : $(NAT_OBJECTS) $(C_OBJECTS)
	$(OCAMLMKLIB) -o gd gd.cmx gdstubs.o -oc ocamlgd $(LIBS)


gd.cmx: gd.cmi gd.ml
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -c gd.ml

gd.cmo: gd.cmi gd.ml
	$(OCAMLC) $(OCAMLCFLAGS) -c gd.ml

gd.cmi: gd.mli
	$(OCAMLC) $(OCAMLCFLAGS) -c gd.mli


gdstubs.o : gdstubs.c
	$(CC) $(CFLAGS) -c gdstubs.c


test : gdtest
	./gdtest gdtest.log

test.opt : gdtest.opt
	./gdtest.opt gdtest.log

gdtest: gdtest.cmo
	$(OCAMLC) -o gdtest -dllpath . str.cma gd.cma gdtest.cmo 

gdtest.cmo: all gdtest.ml
	$(OCAMLC) $(OCAMLCFLAGS) -c gdtest.ml

gdtest.opt: gdtest.cmx
	$(OCAMLOPT) -ccopt "-L ." -o gdtest.opt str.cmxa gd.cmxa gdtest.cmx

gdtest.cmx: opt gdtest.ml
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -c gdtest.ml 


docs : gd.mli
	$(OCAMLDOC) -d doc gd.mli


install :
	files=$$( \
		for f in $(BYTE_ARCHIVE) $(NAT_ARCHIVE) $(STUBLIBS) \
			*.mli *.cmi gd.a META; do \
			if [ -f "$$f" ]; then echo $$f; fi; \
		done; \
	) && \
	$(TASKINSTALL) $(PKGNAME) $$files


uninstall :
	 ocamlfind remove $(PKGNAME)


clean :
	 -rm -f *.cmi *.cmo *.cmx *.cma *.cmxa *.a *.o *.so \
	   gdtest gdtest.opt gdtest.log

=== debian/changelog ===
gd4o (1.0~alpha5-9) unstable; urgency=medium

  * Team upload
  * Switch to dh and bump debhelper compat level to 12
  * Bump Standards-Version to 4.4.0
  * Update Vcs-*
  * Remove Samuel and Romain from Uploaders

 -- Stéphane Glondu <glondu@debian.org>  Tue, 06 Aug 2019 13:54:58 +0200

gd4o (1.0~alpha5-8) unstable; urgency=low

  * Really fix #709853

 -- Romain Beauxis <toots@rastageeks.org>  Wed, 15 May 2013 10:19:47 -0500

gd4o (1.0~alpha5-7) unstable; urgency=low

  * Added BreaksL libgd-gd2-noxpm-ocaml (<< 1.0~alpha5-6~)
    to libgd-ocaml-dev.
  Closes: #709858
  * Added debian/tmp/usr/lib/ocaml to libgd-ocaml.dirs
  Closes: #709853

 -- Romain Beauxis <toots@rastageeks.org>  Wed, 15 May 2013 09:19:41 -0500

gd4o (1.0~alpha5-6) unstable; urgency=low

  * Rebuild against new libgd.
  * Replace xpm/noxpm packages with dummy
    transitional packages.
  * Bump standards version to 3.9.4

 -- Romain Beauxis <toots@rastageeks.org>  Tue, 14 May 2013 19:49:38 -0500

gd4o (1.0~alpha5-5) unstable; urgency=low

  * Team upload
  * Build-Depend on libpng-dev instead of libpng12-dev (Closes: #662342)

 -- Stéphane Glondu <glondu@debian.org>  Mon, 05 Mar 2012 21:28:19 +0100

gd4o (1.0~alpha5-4) unstable; urgency=low

  * Disable native build on archs without ocaml native compiler.

 -- Romain Beauxis <toots@rastageeks.org>  Wed, 12 Oct 2011 02:11:37 +0200

gd4o (1.0~alpha5-3) unstable; urgency=low

  * Also build native library.

 -- Romain Beauxis <toots@rastageeks.org>  Wed, 12 Oct 2011 01:12:02 +0200

gd4o (1.0~alpha5-2) unstable; urgency=low

  * Patched Makefile to pass -fPIC to CFLAGS.
  * Added patch to support flags given through make
    invocation.
  * Added explicit build-deps on libs referenced in Makefile.

 -- Romain Beauxis <toots@rastageeks.org>  Tue, 11 Oct 2011 18:51:33 +0200

gd4o (1.0~alpha5-1) unstable; urgency=low

  * Initial upload to sid (Closes: #644824)

 -- Romain Beauxis <toots@rastageeks.org>  Sun, 09 Oct 2011 15:40:04 +0200

=== debian/control ===
Source: gd4o
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Build-Depends:
 debhelper (>= 12),
 dh-buildinfo,
 ocaml-nox,
 dh-ocaml (>= 0.9),
 libgd-dev,
 ocaml-findlib (>= 1.2.4),
 pkg-config
Standards-Version: 4.4.0
Homepage: http://matt.gushee.net/software/gd4o/
Vcs-Git: https://salsa.debian.org/ocaml-team/gd4o.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/gd4o

Package: libgd-ocaml
Architecture: any
Depends: ${ocaml:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${ocaml:Provides}
Breaks: libgd-gd2-noxpm-ocaml (<< 1.0~alpha5-6~)
Description: OCaml interface to the GD library -- runtime files
 This package provides an interface to the GD library for
 OCaml programmers.
 .
 GD is a graphics library. It allows your code to quickly draw images
 complete with lines, arcs, text, multiple colours, cut and paste from
 other images, flood fills, and write out the result as a PNG file.
 This is particularly useful in World Wide Web applications, where PNG is
 one of the formats accepted for inline images by most browsers.
 .
 This package contains only the shared runtime stub libraries.

Package: libgd-ocaml-dev
Architecture: any
Depends: ${ocaml:Depends},
         libgd-dev,
         libgd-ocaml (= ${binary:Version}), ocaml-findlib, ${misc:Depends}
Provides: ${ocaml:Provides}
Description: OCaml interface to the GD library -- developpement files
 This package provides an interface to the GD library for
 OCaml programmers.
 .
 GD is a graphics library. It allows your code to quickly draw images
 complete with lines, arcs, text, multiple colours, cut and paste from
 other images, flood fills, and write out the result as a PNG file.
 This is particularly useful in World Wide Web applications, where PNG is
 one of the formats accepted for inline images by most browsers.
 .
 This package contains all the development stuff you need to develop
 OCaml programs which use this module.

Package: libgd-gd2-noxpm-ocaml
Architecture: all
Depends: libgd-ocaml
Description: OCaml interface to the GD library -- transitional package
 This is a transitional dummy package to install libgd-gd2-noxpm-ocaml.
 It can safely be removed.

Package: libgd-gd2-noxpm-ocaml-dev
Architecture: all
Depends: libgd-ocaml-dev
Description: OCaml interface to the GD library -- transitional package
 This is a transitional dummy package to install libgd-gd2-noxpm-ocaml-dev.
 It can safely be removed.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/ocaml/ocamlvars.mk

DESTDIR = $(CURDIR)/debian/tmp/$(OCAML_STDLIB_DIR)
# Do not compile dynlink files for now..
DEB_MAKE_BUILD_TARGET := OCAML_DYNLINK="" all

ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
  DEB_MAKE_BUILD_TARGET += opt
endif

%:
	dh $@ --with ocaml

override_dh_auto_build:
	$(MAKE) $(DEB_MAKE_BUILD_TARGET)

override_dh_auto_install:
	mkdir -p $(DESTDIR)
	$(MAKE) install OCAMLFIND_DESTDIR=$(DESTDIR) OCAMLFIND_LDCONF=ignore

=== debian/watch ===
version=3
opts=uversionmangle=s/^([\d.]+)a([\d.]+)$/$1~alpha$2/ \
http://sf.net/gd4o/gd4o-(.+)\.tar\.gz

## gd4o 1.0~alpha5.git20220521.bb52fb2

=== debian/changelog ===
gd4o (1.0~alpha5.git20220521.bb52fb2-1build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 16:48:36 +0200

gd4o (1.0~alpha5.git20220521.bb52fb2-1) unstable; urgency=medium

  * d/watch: fetch current git commits
  * New upstream version 1.0~alpha5.git20220521.bb52fb2
  * Use dh_dune build system
  * Convert copyright file to machine readable format
  * Add Kyle to uploaders (Closes: #934045)

 -- Kyle Robbertze <paddatrapper@debian.org>  Sat, 25 Nov 2023 13:06:12 +0000

gd4o (1.0~alpha5-10) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * Drop transitional packages libgd-gd2-noxpm-* (Closes: #878532)
  * Fix typo in description (Closes: #645001)
  * Add Rules-Requires-Root: no

  [ Debian Janitor ]
  * Bump debhelper from old 12 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Update standards version to 4.6.2, no changes needed.

 -- Stéphane Glondu <glondu@debian.org>  Sat, 12 Aug 2023 07:47:33 +0200

=== debian/control ===
Source: gd4o
Section: ocaml
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Kyle Robbertze <paddatrapper@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-buildinfo,
               dh-ocaml (>= 1.2.2),
               libdune-ocaml-dev,
               libgd-dev,
               ocaml-dune,
               ocaml-findlib,
               ocaml,
               pkg-config
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: http://github.com/savonet/ocaml-gd
Vcs-Git: https://salsa.debian.org/ocaml-team/gd4o.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/gd4o

Package: libgd-ocaml
Architecture: any
Depends: ${ocaml:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${ocaml:Provides}
Description: OCaml interface to the GD library -- runtime files
 This package provides an interface to the GD library for
 OCaml programmers.
 .
 GD is a graphics library. It allows your code to quickly draw images
 complete with lines, arcs, text, multiple colours, cut and paste from
 other images, flood fills, and write out the result as a PNG file.
 This is particularly useful in World Wide Web applications, where PNG is
 one of the formats accepted for inline images by most browsers.
 .
 This package contains only the shared runtime stub libraries.

Package: libgd-ocaml-dev
Architecture: any
Depends: ${ocaml:Depends},
         ${shlibs:Depends},
         libgd-dev,
         libgd-ocaml (= ${binary:Version}), ocaml-findlib, ${misc:Depends}
Provides: ${ocaml:Provides}
Description: OCaml interface to the GD library -- development files
 This package provides an interface to the GD library for
 OCaml programmers.
 .
 GD is a graphics library. It allows your code to quickly draw images
 complete with lines, arcs, text, multiple colours, cut and paste from
 other images, flood fills, and write out the result as a PNG file.
 This is particularly useful in World Wide Web applications, where PNG is
 one of the formats accepted for inline images by most browsers.
 .
 This package contains all the development stuff you need to develop
 OCaml programs which use this module.

=== debian/watch ===
version=4
#opts="filenamemangle=s%(?:.*?)?v?@ANY_VERSION@@ARCHIVE_EXT@%@PACKAGE@-$1.tar.gz%, \
#    uversionmangle=s/^([\d.]+)-alpha([\d.]+)$/$1~alpha$2/" \
#    https://github.com/savonet/ocaml-gd/tags \
#    (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
opts="mode=git, pgpmode=none, \
    pretty=1.0~alpha5.git%cd.%h" \
    https://github.com/savonet/ocaml-gd \
    HEAD

## gd4o 1.1

=== Makefile ===
--- 
+++ 
@@ -26,7 +26,7 @@
 ifdef FT2_LIB
 FT2_FLAG = -DHAVE_FREETYPE
 endif
-CFLAGS = $(CINCLUDES) -W -Wall -Wno-unused \
+CFLAGS = $(CINCLUDES) -fPIC -W -Wall -Wno-unused \
 	$(JPEG_FLAG) $(FT2_FLAG) $(SAFETY_FLAG)
 
 OCAMLCFLAGS=-labels -unsafe
@@ -90,7 +90,7 @@
 
 install :
 	files=$$( \
-		for f in $(BYTE_ARCHIVE) $(NAT_ARCHIVE) $(STUBLIBS) \
+		for f in $(BYTE_ARCHIVE) gd.cmx $(NAT_OBJECTS) $(NAT_ARCHIVE) $(STUBLIBS) \
 			*.mli *.cmi gd.a META; do \
 			if [ -f "$$f" ]; then echo $$f; fi; \
 		done; \

=== debian/changelog ===
gd4o (1.1-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Bump Standards-Version to 4.7.2
  * Build-depend on pkgconf instead of pkg-config
  * Remove dh-buildinfo from Build-Depends

 -- Stéphane Glondu <glondu@debian.org>  Mon, 25 Aug 2025 01:13:47 +0200

gd4o (1.0~alpha5.git20220521.bb52fb2-2) unstable; urgency=medium

  * Team upload
  * Fix compilation with OCaml 5.2.0 (Closes: #1073880)

 -- Stéphane Glondu <glondu@debian.org>  Wed, 07 Aug 2024 03:27:53 +0200

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,17 @@
 Source: gd4o
 Section: ocaml
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Kyle Robbertze <paddatrapper@debian.org>
 Build-Depends: debhelper-compat (= 13),
-               dh-buildinfo,
                dh-ocaml (>= 1.2.2),
                libdune-ocaml-dev,
                libgd-dev,
                ocaml-dune,
                ocaml-findlib,
                ocaml,
-               pkg-config
-Standards-Version: 4.6.2
+               pkgconf
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: http://github.com/savonet/ocaml-gd
 Vcs-Git: https://salsa.debian.org/ocaml-team/gd4o.git

=== debian/watch ===
version=4
opts="searchmode=plain" \
https://api.github.com/repos/savonet/ocaml-gd/releases?per_page=50 \
https://api.github.com/repos/savonet/ocaml-gd/tarball/@ANY_VERSION@
